/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;

public class ComboConId {
	private final static Color colorNoValido = Display.getCurrent().getSystemColor(SWT.COLOR_RED);
	private Color color=null;
	private Vector<String> identificadores = new Vector<String>();
	private Combo objetoCombo = null;

	public ComboConId(Combo objetoCombo) {this.objetoCombo = objetoCombo;this.color=objetoCombo.getForeground();}

	public void borrar(){this.objetoCombo.removeAll();this.identificadores.clear();}
	public void valido(boolean valor){objetoCombo.setForeground(((valor)?color:colorNoValido));}
	public void seleccionarId(String id){
		if (id!=null) if (!id.equals("")) this.objetoCombo.select(this.identificadores.indexOf(id));
		if (this.objetoCombo.getSelectionIndex()<0 && this.objetoCombo.getItemCount()>0) this.objetoCombo.select(0);
	}
	public void seleccionarPrimero(){
		if (this.objetoCombo.getItemCount()>0)
			this.objetoCombo.select(0);
	}
	public String idSeleccionado(){
		String id=null; // Devuelve null si no hay seleccionado (-1)
		if (this.objetoCombo.getSelectionIndex()>=0) id=this.identificadores.get(this.objetoCombo.getSelectionIndex());
		return id;
	}
	public String eSeleccionado(){
		String elemento=null; // Devuelve null si no hay seleccionado (-1)
		if (this.objetoCombo.getSelectionIndex()>=0) elemento=this.objetoCombo.getItem(this.objetoCombo.getSelectionIndex());
		return elemento;
	}
	public void addElemento(String id, String elemento){
		this.objetoCombo.add(elemento);
		this.identificadores.add(id);
	}
	public void deshabilitar(){this.objetoCombo.setEnabled(false);}
	public void habilitar(){this.objetoCombo.setEnabled(true);}
	public Integer numeroElementos(){return this.objetoCombo.getItemCount();}
	public String primerId(){return ((this.identificadores.size()>0)?this.identificadores.firstElement():null);}
	

	public void rellenarConEvaluablesNoRecuNoSeleLista(String idMateriaClase,Integer parcial,ListConId lista){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateriaClase+","+parcial+","+lista+")");
		Vector<Vector<String>> tabla=null;
		if (this.objetoCombo!=null) {
			String idAntiguo = this.idSeleccionado();
			this.borrar();
			tabla = PCuaderno.MiPCuaderno.bbdd.consultarEvaluablesMateriaClaseParcial(idMateriaClase,parcial);
			addElemento("",BBDD.expNo);
			if (tabla!=null)
				for (int i=0;i<tabla.size();i++){
					if (!tabla.get(i).get(0).equals(lista.idSeleccionado())) if (tabla.get(i).get(12)==null) {
						Calendar fecha=Fecha.fechaHora(tabla.get(i).get(3),tabla.get(i).get(2),
								tabla.get(i).get(1),tabla.get(i).get(4),tabla.get(i).get(5));
						this.addElemento(tabla.get(i).get(0),Fecha.formaFechaDiaHora(fecha)+" "+tabla.get(i).get(10)+" "+tabla.get(i).get(6));
					}
				}
			this.seleccionarId(idAntiguo);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateriaClase+") "+((tabla!=null)?tabla.size():"null"));
	}
	public void rellenarConListaSalvoSeleccionado(ListConId lista,String elementoNulo){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+"(list "+((lista!=null)?lista.hashCode():"null)")+")");
		if (this.objetoCombo!=null) {
			String idAntiguo=this.idSeleccionado();
			borrar();
			if (lista!=null) {
				Vector<Vector<String>> elementos=lista.elementosNoSeleccionados();
				if (elementos!=null) if (elementos.size()>0) {
					if (elementoNulo!=null)
						addElemento("",elementoNulo); //Debe ser el primero para seleccionarPrimero()
					for (int i=0;i<elementos.size();i++){
						addElemento(elementos.get(i).get(0),elementos.get(i).get(1));
					}
					if (objetoCombo.getItemCount()>0) objetoCombo.select(0);
				}
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
	}
	public void rellenarTipoEvento(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+"()");
		if (this.objetoCombo!=null) {
			String idAntiguo=this.idSeleccionado();
			this.borrar();
			Vector<Vector<String>> tipos;
			this.addElemento(String.valueOf(BBDD.idTipoTodos),BBDD.expTodos);
			tipos=PCuaderno.MiPCuaderno.bbdd.consultarTiposEvento();
			for (int i=0;i<tipos.size();i++){
				this.addElemento(tipos.get(i).get(0),tipos.get(i).get(1));
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
		
	}
	public void rellenarTipoEvaluable(String idMateria){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+"("+idMateria+")");
		if (this.objetoCombo!=null) {
			String idAntiguo=this.idSeleccionado();
			borrar();
			Vector<Vector<String>> tiposGenericos = PCuaderno.MiPCuaderno.bbdd.consultarTiposEvaluablesParaMateria(null);
			if (tiposGenericos!=null && tiposGenericos.size()>0) {
				for (int fila=0;fila<tiposGenericos.size();fila++){
					addElemento(tiposGenericos.get(fila).get(0), tiposGenericos.get(fila).get(1));
				}
			}
			if (idMateria!=null) {
				Vector<Vector<String>> tiposEspecificos = PCuaderno.MiPCuaderno.bbdd.consultarTiposEvaluablesParaMateria(idMateria);
				if (tiposEspecificos!=null && tiposEspecificos.size()>0) {
					for (int fila=0;fila<tiposEspecificos.size();fila++){
						addElemento(tiposEspecificos.get(fila).get(0), tiposEspecificos.get(fila).get(1));
					}
				}
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
	}
	public void rellenarProfesores(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+"()");
		if (this.objetoCombo!=null) {
			String idAntiguo=this.idSeleccionado();
			borrar();
			Vector<Vector<String>> profesores = PCuaderno.MiPCuaderno.bbdd.consultarProfesor(null);
			if (profesores!=null) {
				for (int fila=0;fila<profesores.size();fila++){
					addElemento(profesores.get(fila).get(0), profesores.get(fila).get(1)+", "+profesores.get(fila).get(2));
				}
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
	}
	public void rellenarMateriaClase(boolean todos){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+" ("+todos+")");
		if (this.objetoCombo!=null) {
			String idAntiguo = this.idSeleccionado();
			this.borrar();
			if (todos) this.addElemento(null,BBDD.expTodos);
			Vector<Vector<String>> tabla = PCuaderno.MiPCuaderno.bbdd.consultarMateriaClase();
			if (tabla!=null) {
				for (int fila=0;fila<tabla.size();fila++){
					this.addElemento(tabla.get(fila).get(0),tabla.get(fila).get(1)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+
							tabla.get(fila).get(2)+" "+tabla.get(fila).get(3)+" ("+tabla.get(fila).get(4)+") "+
							tabla.get(fila).get(5));
				}
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+","+todos+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
	}
	public void rellenarMaterias(boolean todas){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+" ("+todas+")");
		if (this.objetoCombo!=null) {
			String idAntiguo = this.idSeleccionado();
			this.borrar();
			if (todas) this.addElemento(BBDD.idTodos,BBDD.expTodas);
			Vector<Vector<String>> tabla = PCuaderno.MiPCuaderno.bbdd.consultarMateria(null);
			if (tabla!=null) {
				for (int fila=0;fila<tabla.size();fila++){
					this.addElemento(tabla.get(fila).get(0),"("+tabla.get(fila).get(1)+" "+tabla.get(fila).get(4)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+tabla.get(fila).get(5)+"-"+tabla.get(fila).get(6)+") "+
							tabla.get(fila).get(2));
				}
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+","+todas+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
	}
	public void rellenarClases(String idMateria,String idElemento,String elemento){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+"("+idMateria+","+elemento+")");
		if (this.objetoCombo!=null) {
			String idAntiguo = this.idSeleccionado();
			this.borrar();
			if (idElemento!=null && elemento!=null) this.addElemento(idElemento,elemento);
			Vector<Vector<String>> tabla=null;
			if (idMateria!=null) tabla = PCuaderno.MiPCuaderno.bbdd.consultarClasesParaMateria(idMateria);
			else tabla = PCuaderno.MiPCuaderno.bbdd.consultarClase(null,null);
			if (tabla!=null) {
				for (int fila=0;fila<tabla.size();fila++){
					this.addElemento(tabla.get(fila).get(0),tabla.get(fila).get(1)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+
							tabla.get(fila).get(2)+" "+tabla.get(fila).get(3)+" ("+tabla.get(fila).get(7)+", "+tabla.get(fila).get(6)+")");
				}
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
	}
	public void rellenarDiasSemana(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode():"null)")+"()");
		if (this.objetoCombo!=null) {
			String idAntiguo = this.idSeleccionado();
			this.borrar();
			//System.out.println("rellenar DiaSemana :"+Fecha.PrimerDiaSemanaLaboral+","+Fecha.PrimerDiaSemanaFestivo);
			for (int i=Fecha.PrimerDiaSemanaLaboral;i!=Fecha.PrimerDiaSemanaFestivo;i=(i+1)%Fecha.NDiasSemana) {
				Calendar fecha = Calendar.getInstance();
				fecha.set(Calendar.DAY_OF_WEEK, i);
				this.addElemento(Integer.toString(i), Fecha.diaLargo(fecha));
				//System.out.println("rellenar DiaSemana :"+Integer.toString(i)+","+fecha.getDisplayName(Calendar.DAY_OF_WEEK,Calendar.LONG,Locale.getDefault()));
			}
			if (this.objetoCombo.getItemCount()>0) {
				if (idAntiguo!=null) this.seleccionarId(idAntiguo);
				if (this.objetoCombo.getSelectionIndex()<0) this.objetoCombo.select(0);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo "+((this.objetoCombo!=null)?this.objetoCombo.hashCode()+") "+
				this.objetoCombo.getItemCount()+" elements":"null)"));
		
	}
}
