import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.List;
import java.util.Vector;

public class ElegirDeUnList extends Dialog {

	protected Shell shellElegir;
	String texto=null;
	String titulo=null;
	List listLista=null;  
	ListConId listConIdLista=null;
	boolean clave=false;
	private String resultado=null;
	private Button btnAceptar;
	private Button btnCancelar;
	private Vector<Vector<String>> elementos;
	public ElegirDeUnList(Shell parent,String titulo,String texto, Vector<Vector<String>> elementos) {
		super(parent, SWT.TITLE | SWT.BORDER | SWT.APPLICATION_MODAL);
		this.texto=texto;
		this.titulo=titulo;
		this.elementos=elementos;
	}
	public String open() {
		createContents();
		Display display = getParent().getDisplay();
		Monitor primary = display.getPrimaryMonitor ();
		Rectangle bounds = primary.getBounds ();
		Rectangle rect = shellElegir.getBounds ();
		int x = bounds.x + (bounds.width - rect.width) / 2;
		int y = bounds.y + (bounds.height - rect.height) / 2;
		shellElegir.setLocation (x, y);
		shellElegir.open();
		shellElegir.layout();
		rellenaLista();
		while (!shellElegir.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return resultado;
	}
	private void rellenaLista(){
		for (int i=0;i<this.elementos.size();i++)
			listConIdLista.addElemento(elementos.get(i).get(0), elementos.get(i).get(1));
		listLista.select(0);
		listLista.setFocus();
	}
	private void createContents() {
		shellElegir = new Shell(getParent(), SWT.BORDER | SWT.RESIZE | SWT.TITLE | SWT.APPLICATION_MODAL);
		shellElegir.setSize(450, 300);
		shellElegir.setLayout(new GridLayout(1, false));
		shellElegir.setText(PCuaderno.MiPCuaderno.titulo+" - "+this.titulo);
		Composite cmpCampo = new Composite(shellElegir, SWT.NONE);
		cmpCampo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		cmpCampo.setLayout(new GridLayout(2, false));
		Label lblCampo = new Label(cmpCampo, SWT.NONE);
		lblCampo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblCampo.setText(this.texto+": ");
		
		listLista = new List(cmpCampo,SWT.BORDER | SWT.V_SCROLL);
		listConIdLista = new ListConId(listLista);
		listLista.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		Composite cmpBotones = new Composite(shellElegir, SWT.NONE);
		cmpBotones.setLayout(new GridLayout(2, false));
		cmpBotones.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		btnCancelar = new Button(cmpBotones, SWT.NONE);
		btnCancelar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				listLista.setEnabled(false);
				btnCancelar.setEnabled(false);
				btnAceptar.setEnabled(false);
				shellElegir.dispose();
			}
		});
		btnCancelar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Cancel"));
		btnAceptar = new Button(cmpBotones, SWT.NONE);
		btnAceptar.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		btnAceptar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Ok"));
		btnAceptar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				resultado=listConIdLista.idSeleccionado();
				listLista.setEnabled(false);
				btnCancelar.setEnabled(false);
				btnAceptar.setEnabled(false);
				shellElegir.dispose();
			}
		});
	}
}