/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;

public class HoraCombo {
	private final static Color colorNoValido = Display.getCurrent().getSystemColor(SWT.COLOR_RED);
	private Color color=null;
	private Combo objetoCombo=null;
	private Vector<Integer> valores = new Vector<Integer>();
	private Integer ultimoLaboral=-1;
	
	public HoraCombo(Combo combo){this.objetoCombo=combo;this.color=objetoCombo.getForeground();}
	
	public void borrar(){this.objetoCombo.removeAll();this.valores.clear();this.ultimoLaboral=-1;}
	public void valido(boolean valor){objetoCombo.setForeground(((valor)?color:colorNoValido));}
	public void deshabilitar(){this.objetoCombo.setEnabled(false);}
	public void habilitar(){this.objetoCombo.setEnabled(true);}
	public String horaSeleccionada(){return ((this.objetoCombo.getSelectionIndex()>=0)?String.valueOf(valores.get(this.objetoCombo.getSelectionIndex())):null);}
	public void seleccionarHora(String hora){
		Integer vHora=Integer.parseInt(hora);
		if (hora!=null) {
			int indUltHora=valores.size()-1;
			if (indUltHora>=0) {
				if (indUltHora==0) this.objetoCombo.select(0);
				else if (vHora<=valores.get(0)) this.objetoCombo.select(0);
				else if (vHora>=valores.get(indUltHora)) this.objetoCombo.select(indUltHora);
				else {
					for (int i=0;i<indUltHora;i++) {
						if (vHora<=valores.get(i)) {this.objetoCombo.select(i);break;}
					}
				}
			}
		}
		if (this.objetoCombo.getSelectionIndex()<0 && this.objetoCombo.getItemCount()>0) this.objetoCombo.select(0);
	}
	public void rellenaComboLaborales(){
		if (this.objetoCombo!=null && ultimoLaboral!=1) {
			String valorAntiguo = ((this.objetoCombo.getSelectionIndex()>=0)?String.valueOf(this.valores.get(this.objetoCombo.getSelectionIndex())):null);
			this.borrar();
			ultimoLaboral=1;
			for (int i=Fecha.laboralPrimera;i<=Fecha.laboralUltima;i++) {
				this.objetoCombo.add(String.format("%02d",i));
				this.valores.add(i);
			}
			if (valorAntiguo!=null) this.seleccionarHora(valorAntiguo); else this.objetoCombo.select(0);
		}
	}
	public void rellenaComboTodas(){
		if (this.objetoCombo!=null && this.ultimoLaboral!=0) {
			String valorAntiguo = ((this.objetoCombo.getSelectionIndex()>=0)?String.valueOf(this.valores.get(this.objetoCombo.getSelectionIndex())):null);
			this.borrar();
			this.ultimoLaboral=0;
			for (int i=0;i<=23;i++) {
				this.objetoCombo.add(String.format("%02d", i));
				this.valores.add(i);
			}
			if (valorAntiguo!=null) this.seleccionarHora(valorAntiguo); else this.objetoCombo.select(0);
		}
	}
}
