/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Combo;

public class Horario extends Composite {

	private Table tableHorario;
	private Button btnUHNuevo;
	private Button btnUHBorrar;
	private ComboConId comboConIdMateriaClase;
	private ComboConId comboConIdDiaSemana;
	private ListConId listConIdUHs;
	private HoraCombo horaComboInicio;
	private MinutoCombo minutoComboInicio;
	private HoraCombo horaComboFin;
	private MinutoCombo minutoComboFin;
	private Vector<Vector<String>> idHorario;
	public Horario(Composite parent, int style) {super(parent, style);initialize();}
	private void redimensiona(){
	    tableHorario.getColumns()[0].setWidth(100);
		int anchura=(tableHorario.getClientArea().width-tableHorario.getColumns()[0].getWidth())/(tableHorario.getColumnCount()-1);
		if (anchura<100) anchura=80;
	    //System.out.println("anchura = "+tableHorario.getClientArea().width+","+anchura);
	    for (int i=1;i<tableHorario.getColumnCount();i++) {
	    	tableHorario.getColumn(i).setWidth(anchura);
	    }
		anchura=(tableHorario.getClientArea().width-tableHorario.getColumns()[0].getWidth())/(tableHorario.getColumnCount()-1);
		if (anchura<100) anchura=80;
	    for (int i=1;i<tableHorario.getColumnCount();i++) {
	    	tableHorario.getColumn(i).setWidth(anchura);
	    }
	}
	public void actualizar() {
		comboConIdMateriaClase.rellenarMateriaClase(false);
		actualizarHorario();
		actualizarUHsLista(null);
	}
	private void initialize() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		GridLayout gridLayoutHorario = new GridLayout();
		gridLayoutHorario.horizontalSpacing = 2;
		gridLayoutHorario.verticalSpacing = 2;
		gridLayoutHorario.marginWidth = 2;
		gridLayoutHorario.marginHeight = 2;
		GridData gridDataHorario = new GridData();
		gridDataHorario.grabExcessHorizontalSpace = true;
		gridDataHorario.grabExcessVerticalSpace = true;
		gridDataHorario.horizontalAlignment = GridData.FILL;
		gridDataHorario.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataHorario);
		this.setLayout(gridLayoutHorario);
		this.setSize(new Point(685, 340));

		//+++++++++++++++++++++++++++++Horario
		
		GridData gridDataTableHorario = new GridData();
		gridDataTableHorario.grabExcessVerticalSpace = true;
		gridDataTableHorario.heightHint = 200;
		gridDataTableHorario.horizontalAlignment = GridData.FILL;
		gridDataTableHorario.grabExcessHorizontalSpace = true;
		gridDataTableHorario.verticalAlignment = GridData.FILL;
		tableHorario = new Table(this,SWT.BORDER | SWT.READ_ONLY);
		tableHorario.setHeaderVisible(true);
		tableHorario.setLayoutData(gridDataTableHorario);
		tableHorario.setLinesVisible(true);
		tableHorario.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_TableHorario_ToolTip"));

		tableHorario.addListener(SWT.MouseDown, new Listener() {
	      public void handleEvent(Event event) {
	        Rectangle area = tableHorario.getClientArea();
	        Point punto = new Point(event.x, event.y);
	        int fila = tableHorario.getTopIndex();
	        while (fila < tableHorario.getItemCount()) {
	          boolean visible = false;
	          TableItem item = tableHorario.getItem(fila);
	          for (int columna = 0; columna < tableHorario.getColumnCount(); columna++) {
	            Rectangle rect = item.getBounds(columna);
	            if (rect.contains(punto)) {
	              if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Selecting table element " + fila + "," + columna);
	              if (columna>0 && fila>=0) actualizarUHsLista(idHorario.get(fila).get(columna));
	            }
	            if (!visible && rect.intersects(area)) visible = true;
	          }
	          if (!visible) return;
	          fila++;
	        }
	      }
	    });
	    TableColumn tableColumnHoras = new TableColumn(tableHorario, SWT.RIGHT);
	    tableColumnHoras.setText("Hora");
	    tableColumnHoras.setWidth(100);
	    tableColumnHoras.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_TableColumnHoras_ToolTip"));
	    tableColumnHoras.setAlignment(SWT.RIGHT);
		int i=Fecha.PrimerDiaSemanaLaboral;
		do {
		    TableColumn cabeceraDia = new TableColumn(tableHorario, SWT.CENTER);
		    cabeceraDia.setAlignment(SWT.LEFT);
			Calendar fecha = Calendar.getInstance();
			fecha.set(Calendar.DAY_OF_WEEK, i);
			cabeceraDia.setText(Fecha.diaLargo(fecha));
			//System.out.println("Creando cabecera para dia "+Fecha.diaLargo(fecha)+" "+i+","+Fecha.PrimerDiaSemanaFestivo);
			if (i<Fecha.NDiasSemana-1) i++; else i=0;
		} while (i!=Fecha.PrimerDiaSemanaFestivo);
	    tableHorario.addControlListener(new ControlAdapter() {
	        public void controlResized(ControlEvent e) {
	        	redimensiona();
	        }
	    });

		//+++++++++++++++++++++++++++++Gestion de uhs
	    
	    Group grpUHs = new Group(this, SWT.NONE);
	    GridLayout gl_grpUHs = new GridLayout(4, false);
	    gl_grpUHs.verticalSpacing = 2;
	    gl_grpUHs.marginWidth = 2;
	    gl_grpUHs.marginHeight = 2;
	    gl_grpUHs.horizontalSpacing = 2;
	    grpUHs.setLayout(gl_grpUHs);
	    GridData gd_grpUHs = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
	    gd_grpUHs.heightHint = 130;
	    grpUHs.setLayoutData(gd_grpUHs);
	    grpUHs.setText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_grpUHs_Text"));
	    
	    Group groupUHNuevaBorrar = new Group(grpUHs, SWT.NONE);
	    groupUHNuevaBorrar.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, false, 1, 4));
	    GridLayout gl_groupUHNuevaBorrar = new GridLayout(1, false);
	    gl_groupUHNuevaBorrar.verticalSpacing = 2;
	    gl_groupUHNuevaBorrar.marginWidth = 2;
	    gl_groupUHNuevaBorrar.marginHeight = 2;
	    gl_groupUHNuevaBorrar.horizontalSpacing = 2;
	    groupUHNuevaBorrar.setLayout(gl_groupUHNuevaBorrar);
	    
	    btnUHNuevo = new Button(groupUHNuevaBorrar, SWT.NONE);
	    btnUHNuevo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_BtnUHNueva_ToolTip"));
	    btnUHNuevo.addSelectionListener(new SelectionAdapter() {
	    	public void widgetSelected(SelectionEvent e) {
	    		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnUHNueva");
				tableHorario.deselectAll();
	    		if (listConIdUHs.idSeleccionado()!=null){
	    			String id=PCuaderno.MiPCuaderno.bbdd.insertarUHsiguiente(comboConIdMateriaClase.idSeleccionado(),comboConIdDiaSemana.idSeleccionado());
	    			actualizarHorario();
	    			actualizarUHsLista(id);
	    		} else {
	    			String idMateriaClase=comboConIdMateriaClase.primerId();
	    			String idDiaSemana=comboConIdDiaSemana.primerId();
	    			if (idMateriaClase==null || idDiaSemana==null) {
	    				PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_BtnUHNueva_Info_NoClaseMateria"));
	    			} else {
		    			String id=PCuaderno.MiPCuaderno.bbdd.insertarUHsiguiente(idMateriaClase,idDiaSemana);
		    			actualizarHorario();
		    			actualizarUHsLista(id);
	    			}
	    		}
	    	}
	    });
	    btnUHNuevo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_BtnUHNueva_Text"));
	    
	    btnUHBorrar = new Button(groupUHNuevaBorrar, SWT.NONE);
	    btnUHBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_BtnUHNueva_ToolTip"));
	    btnUHBorrar.addSelectionListener(new SelectionAdapter() {
	    	public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnUHBorrar");
				tableHorario.deselectAll();
				String m=PCuaderno.MiPCuaderno.mensajes.getString("Horario_BtnUHBorrar_Preg_Seguro1")+
						" "+listConIdUHs.elementoSeleccionado()+
						PCuaderno.MiPCuaderno.mensajes.getString("Horario_BtnUHBorrar_Preg_Seguro2");
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					PCuaderno.MiPCuaderno.bbdd.borrarUH(listConIdUHs.idSeleccionado());
					listConIdUHs.seleccionarSiguienteOAnterior();
	    			actualizarHorario();
					actualizarUHsLista(null);
				}
	    	}
	    });
	    btnUHBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_BtnUHBorrar_Text"));
	    
	    List listUHs = new List(grpUHs, SWT.BORDER | SWT.V_SCROLL);
	    listUHs.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ListUHs_ToolTip"));
	    GridData gd_listUHs = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 4);
	    gd_listUHs.widthHint = 200;
	    gd_listUHs.heightHint = 50;
	    listUHs.setLayoutData(gd_listUHs);
	    listConIdUHs = new ListConId(listUHs);
	    listUHs.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listUHs "+listConIdUHs.idSeleccionado());
				tableHorario.deselectAll();
				actualizarUHDatos();
			}
		});
	    
	    Label lblMateriaclase = new Label(grpUHs, SWT.NONE);
	    lblMateriaclase.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
	    lblMateriaclase.setText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_LblMateriaclase_Text"));
	    new Label(grpUHs, SWT.NONE);
		
		Combo comboMateriaClase = new Combo(grpUHs, SWT.READ_ONLY);
		comboMateriaClase.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMateriaClase_ToolTip"));
		GridData gd_comboMateriaClase = new GridData(SWT.FILL, SWT.TOP, true, false, 2, 1);
		gd_comboMateriaClase.widthHint = 150;
		comboMateriaClase.setLayoutData(gd_comboMateriaClase);
		comboConIdMateriaClase = new ComboConId(comboMateriaClase);
		comboMateriaClase.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboMateriaClase");
				if (!PCuaderno.MiPCuaderno.bbdd.consultarEvaluableConUHvacio(listConIdUHs.idSeleccionado())) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMateriaClase_Error_Evaluable"));
					Vector<Vector<String>> tabla=PCuaderno.MiPCuaderno.bbdd.consultarUH(null, listConIdUHs.idSeleccionado(), false);
					comboConIdMateriaClase.seleccionarId(tabla.get(0).get(1));
				} else {
					tableHorario.deselectAll();
					PCuaderno.MiPCuaderno.bbdd.modificarUH(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
							,comboConIdMateriaClase.idSeleccionado()
							,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
							,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
					actualizarHorario();
					actualizarUHsLista(null);
				}
			}
		});
		
		Label lblDiaSemana = new Label(grpUHs, SWT.NONE);
		lblDiaSemana.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDiaSemana.setText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_LblDiaSemana_Text"));
		
		Combo comboDiaSemana = new Combo(grpUHs, SWT.READ_ONLY);
		comboDiaSemana.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboDiaSemana_ToolTip"));
		GridData gd_comboDiaSemana = new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1);
		gd_comboDiaSemana.widthHint = 150;
		comboDiaSemana.setLayoutData(gd_comboDiaSemana);
		comboConIdDiaSemana = new ComboConId(comboDiaSemana);
		comboDiaSemana.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboDiaSemana");
				tableHorario.deselectAll();
				Calendar inicio = Fecha.hora(horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada());
				Calendar fin = Fecha.hora(horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
				if (inicio.after(fin)) {
					tramoValido(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboDiaSemana_Info_Fin"));
				} else if (PCuaderno.MiPCuaderno.bbdd.consultarUHsolapada(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada())){
					uHValida(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboDiaSemana_Info_Solapada"));
				} else {
					uHValida(true);
					PCuaderno.MiPCuaderno.bbdd.modificarUH(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,comboConIdMateriaClase.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
					actualizarHorario();
					actualizarUHsLista(null);
				}
			}
		});
		
		Group groupInicioFin = new Group(grpUHs, SWT.NONE);
		GridData gd_groupInicioFin = new GridData(SWT.FILL, SWT.BOTTOM, true, false, 2, 1);
		gd_groupInicioFin.widthHint = 200;
		groupInicioFin.setLayoutData(gd_groupInicioFin);
		GridLayout gl_groupInicioFin = new GridLayout(7, false);
		gl_groupInicioFin.verticalSpacing = 2;
		gl_groupInicioFin.marginWidth = 2;
		gl_groupInicioFin.marginHeight = 2;
		gl_groupInicioFin.horizontalSpacing = 2;
		groupInicioFin.setLayout(gl_groupInicioFin);
		
		Combo comboHoraInicio = new Combo(groupInicioFin, SWT.READ_ONLY);
		comboHoraInicio.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboHoraInicio_ToolTip"));
		GridData gd_comboHoraInicio = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboHoraInicio.widthHint = 60;
		comboHoraInicio.setLayoutData(gd_comboHoraInicio);
		comboHoraInicio.setText("99");
		horaComboInicio = new HoraCombo(comboHoraInicio);
		comboHoraInicio.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboHoraInicio");
				tableHorario.deselectAll();
				Calendar inicio = Fecha.hora(horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada());
				Calendar fin = Fecha.hora(horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
				if (inicio.after(fin)) {
					tramoValido(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboHoraInicio_Info_Fin"));
				} else if (PCuaderno.MiPCuaderno.bbdd.consultarUHsolapada(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada())){
					uHValida(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboHoraInicio_Info_Solapada"));
				} else {
					uHValida(true);
					PCuaderno.MiPCuaderno.bbdd.modificarUH(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
							,comboConIdMateriaClase.idSeleccionado()
							,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
							,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
					actualizarHorario();
					actualizarUHsLista(null);
				}
			}
		});
		
		Label labelDosPuntosInicio = new Label(groupInicioFin, SWT.NONE);
		labelDosPuntosInicio.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		labelDosPuntosInicio.setBounds(0, 0, 68, 17);
		labelDosPuntosInicio.setText(":");
		
		Combo comboMinutoInicio = new Combo(groupInicioFin, SWT.READ_ONLY);
		comboMinutoInicio.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMinutoInicio_ToolTip"));
		GridData gd_comboMinutoInicio = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboMinutoInicio.widthHint = 60;
		comboMinutoInicio.setLayoutData(gd_comboMinutoInicio);
		comboMinutoInicio.setText("99");
		minutoComboInicio = new MinutoCombo(comboMinutoInicio);
		comboMinutoInicio.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboMinutoInicio");
				tableHorario.deselectAll();
				Calendar inicio = Fecha.hora(horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada());
				Calendar fin = Fecha.hora(horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
				if (inicio.after(fin)) {
					tramoValido(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMinutoInicio_Info_Fin"));
				} else if (PCuaderno.MiPCuaderno.bbdd.consultarUHsolapada(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada())){
					uHValida(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMinutoInicio_Info_Solapada"));
				} else {
					uHValida(true);
					PCuaderno.MiPCuaderno.bbdd.modificarUH(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,comboConIdMateriaClase.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
					actualizarHorario();
					actualizarUHsLista(null);
				}
			}
		});
		
		Label labelGuion = new Label(groupInicioFin, SWT.NONE);
		labelGuion.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		labelGuion.setText("-");
		
		Combo comboHoraFin = new Combo(groupInicioFin, SWT.READ_ONLY);
		comboHoraFin.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboHoraFin_ToolTip"));
		GridData gd_comboHoraFin = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboHoraFin.widthHint = 60;
		comboHoraFin.setLayoutData(gd_comboHoraFin);
		comboHoraFin.setText("99");
		horaComboFin = new HoraCombo(comboHoraFin);
		comboHoraFin.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboHoraFin");
				tableHorario.deselectAll();
				Calendar inicio = Fecha.hora(horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada());
				Calendar fin = Fecha.hora(horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
				if (inicio.after(fin)) {
					tramoValido(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboHoraFin_Info_Fin"));
				} else if (PCuaderno.MiPCuaderno.bbdd.consultarUHsolapada(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada())){
					uHValida(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboHoraFin_Info_Solapada"));
				} else {
					uHValida(true);
					PCuaderno.MiPCuaderno.bbdd.modificarUH(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,comboConIdMateriaClase.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
					actualizarHorario();
					actualizarUHsLista(null);
				}
			}
		});
		
		Label labelDosPuntosFin = new Label(groupInicioFin, SWT.NONE);
		labelDosPuntosFin.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		labelDosPuntosFin.setText(":");
		
		Combo comboMinutoFin = new Combo(groupInicioFin, SWT.READ_ONLY);
		comboMinutoFin.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMinutoFin_ToolTip"));
		GridData gd_comboMinutoFin = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboMinutoFin.widthHint = 60;
		comboMinutoFin.setLayoutData(gd_comboMinutoFin);
		comboMinutoFin.setText("99");
		minutoComboFin = new MinutoCombo(comboMinutoFin);
		comboMinutoFin.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboMinutoFin");
				tableHorario.deselectAll();
				Calendar inicio = Fecha.hora(horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada());
				Calendar fin = Fecha.hora(horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
				if (inicio.after(fin)) {
					tramoValido(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMinutoFin_Info_Fin"));
				} else if (PCuaderno.MiPCuaderno.bbdd.consultarUHsolapada(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada())){
					uHValida(false);
					PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ComboMinutoFin_Info_Solapada"));
				} else {
					uHValida(true);
					PCuaderno.MiPCuaderno.bbdd.modificarUH(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
						,comboConIdMateriaClase.idSeleccionado()
						,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
						,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
					actualizarHorario();
					actualizarUHsLista(null);
				}
			}
		});
		
		comboConIdDiaSemana.rellenarDiasSemana();
		horaComboInicio.rellenaComboLaborales();
		horaComboFin.rellenaComboLaborales();
		minutoComboInicio.rellena();
		minutoComboFin.rellena();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end");
	}
	public void uHValida(boolean valido){
		comboConIdDiaSemana.valido(valido);
		tramoValido(valido);
	}
	public void tramoValido(boolean valido){
		horaComboInicio.valido(valido);
		minutoComboInicio.valido(valido);
		horaComboFin.valido(valido);
		minutoComboFin.valido(valido);
	}
	public void actualizarHorario(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		this.tableHorario.removeAll();
		for (;this.tableHorario.getItems().length>0;) this.tableHorario.getItems()[0].dispose();
		Vector<String> horas = new Vector<String>();
		Vector<Vector<String>> horario = new Vector<Vector<String>>();
		idHorario = null;
		idHorario = new Vector<Vector<String>>();
		Vector<Vector<String>> uhs = new Vector<Vector<String>>();
		uhs=PCuaderno.MiPCuaderno.bbdd.consultarUH(null,null,false);
		if (uhs!=null) if (uhs.size()>0) {
			for (int i=0;i<uhs.size();i++) {
				String tramo=Fecha.formaUHoraria(uhs.get(i).get(3),uhs.get(i).get(4),uhs.get(i).get(5),uhs.get(i).get(6));
				String materiaClase=uhs.get(i).get(7)+" "+uhs.get(i).get(8)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+uhs.get(i).get(9)+" "+uhs.get(i).get(10);
				int fila=horas.indexOf(tramo);
				if (fila<0) {
					horas.addElement(tramo);
					fila=horas.size()-1;
					idHorario.add(new Vector<String>());
					for (int j=0;j<Fecha.NDiasSemanaLaborales+1;j++) idHorario.get(fila).add("");
					horario.add(new Vector<String>());
					for (int j=0;j<Fecha.NDiasSemanaLaborales+1;j++) horario.get(fila).add("");
					horario.get(fila).set(0,tramo);
				}
				int dia = Integer.parseInt(uhs.get(i).get(2));
				int columna = (dia>=Fecha.PrimerDiaSemanaLaboral)?dia+1-Fecha.PrimerDiaSemanaLaboral:dia+Fecha.NDiasSemana-Fecha.PrimerDiaSemanaLaboral;
				//System.out.println("UH ("+fila+","+columna+"):"+tramo+" => "+materiaClase);
				horario.get(fila).set(columna, materiaClase);
				idHorario.get(fila).set(columna, uhs.get(i).get(0));
				//System.out.println("Añadiendo unidad horaria: ("+(i+1)+"/"+uHorarias.size()+") "+fila.get(0));
			}
		}
		for (int i=0;i<horario.size();i++){
		    TableItem item = new TableItem(tableHorario, SWT.NONE);
			for (int j=0;j<horario.get(0).size();j++){
			    item.setText(j,horario.get(i).get(j));
			}
		}
		redimensiona();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",true);
	}
	public void actualizarUHsLista(String id){
		listConIdUHs.rellenarUHs();
		listConIdUHs.seleccionarId(id);
		actualizarUHDatos();
	}
	public void actualizarUHDatos(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		if (listConIdUHs.idSeleccionado()==null){
			uHValida(true);
			comboConIdMateriaClase.deshabilitar();
			comboConIdDiaSemana.deshabilitar();
			horaComboInicio.deshabilitar();
			minutoComboInicio.deshabilitar();
			horaComboFin.deshabilitar();
			minutoComboFin.deshabilitar();
			btnUHBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> uh=PCuaderno.MiPCuaderno.bbdd.consultarUH(null,listConIdUHs.idSeleccionado(),false);
			comboConIdMateriaClase.seleccionarId(uh.get(0).get(1));
			comboConIdMateriaClase.habilitar();
			comboConIdDiaSemana.seleccionarId(uh.get(0).get(2));
			comboConIdDiaSemana.habilitar();
			horaComboInicio.seleccionarHora(uh.get(0).get(3));
			minutoComboInicio.seleccionarMinuto(uh.get(0).get(4));
			horaComboFin.seleccionarHora(uh.get(0).get(5));
			minutoComboFin.seleccionarMinuto(uh.get(0).get(6));
			horaComboInicio.habilitar();
			minutoComboInicio.habilitar();
			horaComboFin.habilitar();
			minutoComboFin.habilitar();
			Calendar inicio = Fecha.hora(horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada());
			Calendar fin = Fecha.hora(horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada());
			if (inicio.after(fin)) {
				tramoValido(false);
				PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ActualizarUHDatos_Info_Fin"));
			} else if (PCuaderno.MiPCuaderno.bbdd.consultarUHsolapada(listConIdUHs.idSeleccionado(),comboConIdDiaSemana.idSeleccionado()
					,horaComboInicio.horaSeleccionada(),minutoComboInicio.minutoSeleccionada()
					,horaComboFin.horaSeleccionada(),minutoComboFin.minutoSeleccionada())){
				uHValida(false);
				PCuaderno.MiPCuaderno.informacion(PCuaderno.MiPCuaderno.mensajes.getString("Horario_ActualizarUHDatos_Info_Solapa"));
			} else {
				uHValida(true);
			}
			btnUHBorrar.setEnabled(true);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",true);
	}
}
